<template>
    <navbar />
    <div class="w-full p-8">
        <div class="flex flex-col bg-white w-full items-center p-5 gap-5 rounded">
            <p class="text-2xl"><strong>Administración</strong></p>
            <p class="text-lg">Nuevo Usuario</p>
            <form class="flex gap-3 justify-center" id="form" @submit.prevent="registrar()">
                <div class="flex flex-col gap-2 p-5 items-end">
                    <label for="username" class="h-8">Nombre de usuario</label>
                    <label for="nombre" class="h-8">Nombre</label>
                    <label for="apellidoPaterno" class="h-8">Apellido paterno</label>
                    <label for="apellidoMaterno" class="h-8">Apellido materno</label>
                    <label for="correo" class="h-8">Correo</label>
                    <label for="password" class="h-8">Contraseña</label>
                    <label class="h-8" for="rol">Rol de usuario</label>
                </div>
                <div class="flex flex-col gap-2 p-5 w-80">
                    <input v-model="newUser.username" id="nombreUsuario" class="input input-bordered input-sm" placeholder="11222333-4" required>
                    <input v-model="newUser.nombre" id="nombre" class="input input-bordered input-sm" placeholder="Jose" required>
                    <input v-model="newUser.apellidoPaterno" id="apellidoPaterno" class="input input-bordered input-sm" placeholder="Rupallan" required>
                    <input v-model="newUser.apellidoMaterno" id="apellidoMaterno" class="input input-bordered input-sm" placeholder="Diaz" required>
                    <input v-model="newUser.correo" id="correo" class="input input-bordered input-sm" placeholder="email@dciIntranet.cl" required>
                    <input v-model="newUser.password" id="new-password" class="input input-bordered input-sm" placeholder="Contraseña"
                        type="password" required>
                    <select v-model="newUser.rol" class="select select-sm select-secondary" id="rol" required>
                        <option v-for="(rol, index) in roles" :key="index">{{ rol }}</option>
                    </select>
                </div>
            </form>
            <h2 v-if="msg">{{msg}}</h2>
            <div class="flex gap-3">
                <a class="btn btn-secondary" :href="'/admin'">Volver</a>
                <button class="btn btn-primary" type="submit" form="form">Crear</button>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios'
import navbar from '../../components/Navbar.vue'

export default {
    components: { navbar },
    data() {
        return {
            roles: {},
            newUser: {
                nombre: null,
                password: null,
                apellidoPaterno: null,
                apellidoMaterno: null,
                correo: null,
                username: null,
                rol: null
            },
            msg: null
        }
    },
    async mounted() {
        const response = await axios.get("cuentas/roles")
        this.roles = response.data
    },
    methods: {
        registrar(){
            axios.post("cuentas/registrar",this.newUser,{
                headers: {
                    Authorization: localStorage.getItem('auth')
                }
            }).then( res => {
                console.log(res)
                this.msg = null
                alert("Usuario registrado exitosamente")
                window.location.reload()
            })
            .catch( err => {
                console.log(err)
                this.msg = err.response.data
            })
        }
    }
}
</script>

<style>

</style>